type operator = Add | Sub | Mul | Div | Lt | Leq | Gt | Geq | Equal | Neq |And | Or

type basic_type = Int | Double | Text | Bool

type config_dec = Config_dec of string * string

type  type_spc =
		  Atom_type_spc of basic_type
	  	| List_type_spc of basic_type

type mapping_relation = Map_rel of type_spc * type_spc * type_spc * type_spc

type expr =
	  Id of string

	| Integer_Const of int
	| Double_Const of float
	| Text_Const of string
	| Bool_Const of bool

	| Uminus of expr

	| Split of string * string
	
	| Binop of expr * operator * expr

	| Assign of string * expr

	| Vdcl of type_spc * string
	| Vdfn of type_spc * string * expr

type stmt = 
	  Block of stmt list
	| Expr of expr
	| Emit of string * string
	| If of expr * stmt * stmt  
	| Foreach of string * string * stmt

type mapper_def = {
			map_name : string;
			map_rel : mapping_relation;
			map_paras : string list;
			map_body: stmt list;
		  }

type reducer_def = {
			reduce_name : string;
			red_rel : mapping_relation;
			red_paras : string list;
			red_body: stmt list;
		   }

type program = Program of config_dec * mapper_def * reducer_def

