#!/bin/sh

# Note that the first argument is the hadoop home directory.
# Noth that the second argument is the java file directory.

# Get the name of the java file.
#
filename=$(basename "$2")

# Get the path of the bash script file.
#
path=$(pwd)

# Make a temp folder for the java and class files.
#
mkdir $path/hadoop.${filename%.*}.temp

# Copy the java file to the new generated folder.
#
cp $2 $path/hadoop.${filename%.*}.temp

# Switch to the hadoop home directory.
cd $1

# Compile the java file with the hadoop library.
#
javac -classpath hadoop-core-0.20.203.0.jar:lib/commons-cli-1.2.jar $path/hadoop.${filename%.*}.temp/$filename 

# Switch to the temp folder.
#
cd $path/hadoop.${filename%.*}.temp

#Make the jar file.
#
jar cvf ${filename%.*}.jar *.class

#Copy the jar file to the script file directory.
#
cp ${filename%.*}.jar $path

#Delete the temp folder.
#
rm -r $path/hadoop.${filename%.*}.temp

